#include <VarSpeedServo.h> 
 
VarSpeedServo servoD1;  // create servo object to control a servo 
VarSpeedServo servoD2;                
VarSpeedServo servoD3;
                                                                    //  o   x     o    x    o    x  o    x    o    x
//SERVO POSITION ARRAYS    1    2    3    4   5    6   7    8    9   | 10  11    12   13   14   15  16   17   18   19
int s1PosArray[20] = {0,  70,  65,  73,  88,  88,  91, 106, 107, 109, 126, 128, 131, 131, 132, 136, 112, 115, 93, 102};
int s2PosArray[20] = {0, 119, 134, 146, 103, 123, 140,  91, 109, 130, 100, 114,  82, 132,  64, 148,  81, 149, 94, 155};
int s3PosArray[20] = {0,  35,  46,  62,  44,  62,  79,  51,  70,  95,  68,  84,  47, 107,  32, 132,  33, 116, 26,  99};
//int testPOS = 5;

//PIN CONFIG
const int btn1 = 2;
const int btn2 = 3;
const int btn3 = 4;
const int rowLED = 5;  //Row LED
const int colLED = 6;  //Coloum LED
const int magnetPwr = 7;  //Magnet Power
const int servoPwr = 8;

int servoSpeed = 25; //0 = slow, 255 = fast
int inputPOS = 5;  //Middle Position
int move = 10;  //Piece Count
int blockPOS = 0;  
int winner = 0;
int freePOS = 0;
int oCnt = 10;  //o Piece count
int xCnt = 11;  //x Piece count

int board[10] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0};   //Remembers the game board, 0 = empty, 1 = computer or player1, 2 = player2
 
void setup() 
{ 
  randomSeed(analogRead(0));  //Setup Random seed of floating analog read
  //Serial.begin(9600);
  
  servoD1.attach(9);  // 0 is Up or TIGHT, 180 is Down or LOOSE 
  servoD2.attach(10);
  servoD3.attach(11);  //REVERSED
  
  pinMode(btn1, INPUT);
  pinMode(btn2, INPUT);
  pinMode(btn3, INPUT);  
  pinMode(rowLED, OUTPUT);
  pinMode(colLED, OUTPUT);
  pinMode(magnetPwr, OUTPUT);  
  pinMode(servoPwr, OUTPUT);       //Implement the servo power switching relay
   
  digitalWrite(magnetPwr, LOW);    //Turn MAGNET Off
  digitalWrite(servoPwr, HIGH);    //Turn Servos ON, This stops the servos moving on reset/reprogram etc
  moveToPOS(5);  //Move to the middle Position 
} 
 
void loop() 
{                
  if(winner > 0)  //Reset Variables
  {
    inputPOS = 0;
    winner = 0;
  }
  posInput();  //User goes first
  checkWin();  //See if player has won
  canWin();    //Arduino checks if it can win then win's
  if (winner == 0)  block();     //Blocks if need or places random piece.
  
  drawBoard();
 /* Serial.print(xCnt);
  Serial.print(" is xCnt, oCnt = "); 
  Serial.println(oCnt); */
} 

void drawBoard()
{
  Serial.print(board[1]);
  Serial.print(",");
  Serial.print(board[2]);
  Serial.print(",");
  Serial.println(board[3]);
  Serial.print(board[4]);
  Serial.print(",");
  Serial.print(board[5]);
  Serial.print(",");
  Serial.println(board[6]);  
  Serial.print(board[7]);
  Serial.print(",");
  Serial.print(board[8]);
  Serial.print(",");
  Serial.println(board[9]);
  Serial.println();
}














